"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_dom_1 = require("react-dom");
var mobx_react_1 = require("mobx-react");
exports.observer = mobx_react_1.observer;
var Cans = (function () {
    function Cans() {
        this.__routerComponent = React.createElement('div', null, 'cans');
        this.__plugins = [];
        this.__models = [];
        this.models = {};
        this.plugins = {};
    }
    Cans.prototype.__getInjectList = function () {
        return this.__models.map(function (model) { return model.namespace; }).filter(function (_) { return _; });
    };
    Cans.prototype.route = function (routeFunc) {
        // wrap provider
        var providerProps = {};
        this.__routerComponent = React.createElement(mobx_react_1.Provider, this.models, routeFunc());
    };
    Cans.prototype.model = function (model) {
        // registry model
        if (typeof model.observable === 'function') {
            this.models[model.namespace] = model.observable(this);
        }
        else {
            this.models[model.namespace] = model.observable;
        }
        this.__models.push(model);
    };
    Cans.prototype.start = function (el) {
        react_dom_1.render(this.__routerComponent, el);
        this.__mountedRoot = el;
    };
    Cans.prototype.use = function (plugin) {
        // registry plugin
        this.plugins[plugin.namespace] = plugin.observable(this);
        this.__plugins.push(plugin);
    };
    return Cans;
}());
exports.Cans = Cans;
var createCansApp = function () {
    return new Cans();
};
// model inject helper
exports.inject = function (view) { return mobx_react_1.inject(function (models) { return ({ models: models }); })(mobx_react_1.observer(view)); };
exports.default = createCansApp;
